<?php

declare(strict_types=1);

use PhpCsFixer\Config;
use PhpCsFixer\Finder;

$finder = (new Finder())
    ->files()
    ->name('*.php')
    ->in('src')
    ->in('tests')
    ->exclude('var')
;

return (new Config())
    ->setRiskyAllowed(true)
    ->setRules([
        '@PHP74Migration' => true,
        '@PhpCsFixer' => true,
        'declare_strict_types' => true,
        'global_namespace_import' => true,
        'concat_space' => false,
        'function_typehint_space' => false,
        'method_argument_space' => false,
        'types_spaces' => ['space_multiple_catch' => 'single'],
        'phpdoc_order' => ['order' => ['param', 'throws', 'return']],
        'phpdoc_separation' => ['groups' => [['ORM\*'], ['Assert\*'], ['Serializer\*'], ['SWG\*'], ['Constraints\*']]],
    ])
    ->setFinder($finder)
;
