<?php

declare(strict_types=1);

namespace Ifacesoft\Ice\Query\Application\Command\Cli;

use Ifacesoft\Ice\Data\Domain\ValueObject\Scalar\StringValue\XmlString;
use Ifacesoft\Ice\Query\Application\UseCase\GenerateEntitiesFromDbwrenchUseCase;
use Symfony\Component\Console\Attribute\AsCommand;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

#[AsCommand(name: 'ice-query:generate-entities-from-dbwrench')]
final class GenerateEntitiesFromDbwrenchCommand extends Command
{
    private GenerateEntitiesFromDbwrenchUseCase $generateEntitiesFromDbwrenchUseCase;

    public function __construct(
        GenerateEntitiesFromDbwrenchUseCase $generateEntitiesFromDbwrenchUseCase
    ) {
        parent::__construct();

        $this->generateEntitiesFromDbwrenchUseCase = $generateEntitiesFromDbwrenchUseCase;
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        /** @var string $string */
        $string = file_get_contents('share/moex2.xml');

        ($this->generateEntitiesFromDbwrenchUseCase)(new XmlString($string));

        return Command::SUCCESS;
        // or return this if some error happened during the execution
        // (it's equivalent to returning int(1))
        // return Command::FAILURE;

        // or return this to indicate incorrect command usage; e.g. invalid options
        // or missing arguments (it's equivalent to returning int(2))
        // return Command::INVALID
    }
}
