<?php

declare(strict_types=1);

namespace Ifacesoft\Ice\Query\Application\Command\Cli\Once;

use Ifacesoft\Ice\Data\Domain\ValueObject\Scalar\StringValue\XmlString;
use Ifacesoft\Ice\Query\Application\UseCase\Once\GenerateDtosDbwrenchUseCase;
use Symfony\Component\Console\Attribute\AsCommand;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

#[AsCommand(name: 'ice-query:once-generate-dtos-dbwrench')]
final class GenerateDtosDbwrenchCommand extends Command
{
    private GenerateDtosDbwrenchUseCase $generateDtosDbwrenchUseCase;

    public function __construct(
        GenerateDtosDbwrenchUseCase $generateDtosDbwrenchUseCase
    ) {
        parent::__construct();

        $this->generateDtosDbwrenchUseCase = $generateDtosDbwrenchUseCase;
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        /** @var string $string */
        $string = file_get_contents('share/moex2.xml');

        ($this->generateDtosDbwrenchUseCase)(new XmlString($string));

        return Command::SUCCESS;
        // or return this if some error happened during the execution
        // (it's equivalent to returning int(1))
        // return Command::FAILURE;

        // or return this to indicate incorrect command usage; e.g. invalid options
        // or missing arguments (it's equivalent to returning int(2))
        // return Command::INVALID
    }
}
