<?php

declare(strict_types=1);

namespace Ifacesoft\Ice\Query\Domain\Dto;

use Ifacesoft\Ice\Data\Domain\Abstracts\AbstractStruct;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\Attributes;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl;
use ReflectionException;

final class Dbwrench extends AbstractStruct
{
    private Attributes $attributes;

    /**
     * @var TblCollection<int, Tbl>
     */
    private TblCollection $Tbl;

    private string $CustomTypes;

    /**
     * @param TblCollection<int, Tbl> $Tbl
     *
     * @throws ReflectionException
     */
    public function __construct(Attributes $attributes, TblCollection $Tbl, string $CustomTypes)
    {
        $this->attributes = $attributes;
        $this->Tbl = $Tbl;
        $this->CustomTypes = $CustomTypes;

        parent::__construct();
    }

    public function getAttributes(): Attributes
    {
        return $this->attributes;
    }

    /**
     * @return TblCollection<int, Tbl>
     */
    public function getTbl(): TblCollection
    {
        return $this->Tbl;
    }

    public function getCustomTypes(): string
    {
        return $this->CustomTypes;
    }
}
