<?php

declare(strict_types=1);

namespace Ifacesoft\Ice\Query\Domain\Dto\Dbwrench;

use Ifacesoft\Ice\Data\Domain\Abstracts\Struct\AbstractConfig;
use Ifacesoft\Ice\Data\Domain\Config\ArrayValueConfig;
use Ifacesoft\Ice\Data\Domain\ValueObject\ArrayValue\Collection;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl;
use Traversable;

/**
 * @template TKey of int
 * @template TValue of Tbl
 *
 * @template-extends Collection<int, Tbl>
 */
final class TblCollection extends Collection
{
    public function __construct(array $value)
    {
        parent::__construct($value);
    }

    public static function config(?AbstractConfig $config = null): ?AbstractConfig
    {
        return parent::config(
            new ArrayValueConfig('int', Tbl::class)
        );
    }

    public function getIterator(): Traversable
    {
        return (function () {
            /** @var array<string, mixed> $val */
            foreach (parent::getIterator() as $key => $val) {
                yield $key => Tbl::newInstance($val);
            }
        })();
    }

    public function get($index, $value = null, bool $isRequire = true): Tbl
    {
        /** @var array<string, mixed> $data */
        $data = $this->getValue()[$index];

        return Tbl::newInstance($data);
    }
}
