<?php

declare(strict_types=1);

namespace Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\ClCollection;

use Ifacesoft\Ice\Data\Domain\Abstracts\AbstractStruct;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\ClCollection\Cl\Attributes;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\ClCollection\Cl\DTCollection;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\ClCollection\Cl\DTCollection\DT;
use ReflectionException;

final class Cl extends AbstractStruct
{
    private Attributes $attributes;

    /**
     * @var DTCollection<int, DT>
     */
    private DTCollection $DT;

    /**
     * @param DTCollection<int, DT> $DT
     *
     * @throws ReflectionException
     */
    public function __construct(Attributes $attributes, DTCollection $DT)
    {
        $this->attributes = $attributes;
        $this->DT = $DT;

        parent::__construct();
    }

    public function getAttributes(): Attributes
    {
        return $this->attributes;
    }

    /**
     * @return DTCollection<int, DT>
     */
    public function getDT(): DTCollection
    {
        return $this->DT;
    }
}
