<?php

declare(strict_types=1);

namespace Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\FkCollection;

use Ifacesoft\Ice\Data\Domain\Abstracts\AbstractStruct;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\FkCollection\Fk\Attributes;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\FkCollection\Fk\CdTbCollection;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\FkCollection\Fk\CdTbCollection\CdTb;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\FkCollection\Fk\ClPrCollection;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\FkCollection\Fk\ClPrCollection\ClPr;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\FkCollection\Fk\PrTbCollection;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\FkCollection\Fk\PrTbCollection\PrTb;
use ReflectionException;

final class Fk extends AbstractStruct
{
    private Attributes $attributes;

    /**
     * @var PrTbCollection<int, PrTb>
     */
    private PrTbCollection $PrTb;

    /**
     * @var CdTbCollection<int, CdTb>
     */
    private CdTbCollection $CdTb;

    /**
     * @var ClPrCollection<int, ClPr>
     */
    private ClPrCollection $ClPr;

    /**
     * @param PrTbCollection<int, PrTb> $PrTb
     * @param CdTbCollection<int, CdTb> $CdTb
     * @param ClPrCollection<int, ClPr> $ClPr
     *
     * @throws ReflectionException
     */
    public function __construct(Attributes $attributes, PrTbCollection $PrTb, CdTbCollection $CdTb, ClPrCollection $ClPr)
    {
        $this->attributes = $attributes;
        $this->PrTb = $PrTb;
        $this->CdTb = $CdTb;
        $this->ClPr = $ClPr;

        parent::__construct();
    }

    public function getAttributes(): Attributes
    {
        return $this->attributes;
    }

    /**
     * @return PrTbCollection<int, PrTb>
     */
    public function getPrTb(): PrTbCollection
    {
        return $this->PrTb;
    }

    /**
     * @return CdTbCollection<int, CdTb>
     */
    public function getCdTb(): CdTbCollection
    {
        return $this->CdTb;
    }

    /**
     * @return ClPrCollection<int, ClPr>
     */
    public function getClPr(): ClPrCollection
    {
        return $this->ClPr;
    }
}
