<?php

declare(strict_types=1);

namespace Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl;

use Ifacesoft\Ice\Data\Domain\Abstracts\Struct\AbstractConfig;
use Ifacesoft\Ice\Data\Domain\Config\ArrayValueConfig;
use Ifacesoft\Ice\Data\Domain\ValueObject\ArrayValue\Collection;
use Ifacesoft\Ice\Query\Domain\Dto\Dbwrench\TblCollection\Tbl\PkCollection\Pk;
use Traversable;

/**
 * @template TKey of int
 * @template TValue of Pk
 *
 * @template-extends Collection<int, Pk>
 */
final class PkCollection extends Collection
{
    public function __construct(array $value)
    {
        parent::__construct($value);
    }

    public static function config(?AbstractConfig $config = null): ?AbstractConfig
    {
        return parent::config(
            new ArrayValueConfig('int', Pk::class)
        );
    }

    public function getIterator(): Traversable
    {
        return (function () {
            /** @var array<string, mixed> $val */
            foreach (parent::getIterator() as $key => $val) {
                yield $key => Pk::newInstance($val);
            }
        })();
    }

    public function get($index, $value = null, bool $isRequire = true): Pk
    {
        /** @var array<string, mixed> $data */
        $data = $this->getValue()[$index];

        return Pk::newInstance($data);
    }
}
