<?php

declare(strict_types=1);

namespace Ifacesoft\Ice\Query\Domain\Dto\Table\Column;

use Ifacesoft\Ice\Data\Domain\Abstracts\AbstractStruct;
use Ifacesoft\Ice\Query\Domain\ValueObject\Table;

final class Join extends AbstractStruct
{
    private Table $tableName;
    private string $columnName;

    public function __construct(
        Table  $tableName,
        string $joinColumn
    ) {
        $this->tableName = $tableName;
        $this->columnName = $joinColumn;

        parent::__construct();
    }

    public function getTableName(): Table
    {
        return $this->tableName;
    }

    public function getColumnName(): string
    {
        return $this->columnName;
    }
}
